#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

void trace_integer( int a ) {
	printf( "%d", a );
}

void _unhandled_error( ) {
	printf( "Unhandled error\n" );
	abort();
}

void _bad_fail() {
	printf( "Bad fail\n" );
	abort();
}

void * count_malloc( size_t sz ) {
	return malloc(sz);
}

void count_free( void * ptr ) {
	free(ptr);
}

void _duplicate_release_shared() {
	printf( "Duplicate release shared\n" );
	abort();
}

void _access_unset_optional() {
	//TODO: needs to be generate an error in Leaf instead
	printf("access-unset-optional\n");
	abort();
}

void _void_destructor( void* obj ) {
}

//TODO: provide a way to link to variables like errno directly
int _get_errno() {
	return errno;
}

